function compile()  

if ispc
    %{
    mex private/edgesDetectMex.cpp -outdir private
    mex private/edgesNmsMex.cpp    -outdir private
    mex private/spDetectMex.cpp    -outdir private 
    mex private/edgeBoxesMex.cpp   -outdir private
    %}
    mex private/edgeBoxesScoreWindowsMex.cpp   -outdir private
else
    %{
    -- problematic due to heavy core usage --
    mex private/edgesDetectMex.cpp -outdir private '-DUSEOMP' CXXFLAGS="\$CXXFLAGS -fopenmp" LDFLAGS="\$LDFLAGS -fopenmp"
    mex private/edgesNmsMex.cpp    -outdir private '-DUSEOMP' CXXFLAGS="\$CXXFLAGS -fopenmp" LDFLAGS="\$LDFLAGS -fopenmp"
    mex private/spDetectMex.cpp    -outdir private '-DUSEOMP' CXXFLAGS="\$CXXFLAGS -fopenmp" LDFLAGS="\$LDFLAGS -fopenmp"
    mex private/edgeBoxesMex.cpp   -outdir private '-DUSEOMP' CXXFLAGS="\$CXXFLAGS -fopenmp" LDFLAGS="\$LDFLAGS -fopenmp"
    mex private/edgeBoxesScoreWindowsMex.cpp   -outdir private '-DUSEOMP' CXXFLAGS="\$CXXFLAGS -fopenmp" LDFLAGS="\$LDFLAGS -fopenmp"
    %}

    mex private/edgesDetectMex.cpp -outdir private 
    mex private/edgesNmsMex.cpp    -outdir private
    mex private/spDetectMex.cpp    -outdir private
    mex private/edgeBoxesMex.cpp   -outdir private
    mex private/edgeBoxesScoreWindowsMex.cpp   -outdir private 
end

%Here [OMPPARAMS] are parameters for OpenMP and are OS and compiler dependent.
%  Windows:  [OMPPARAMS] = '-DUSEOMP' 'OPTIMFLAGS="$OPTIMFLAGS' '/openmp"'
%  Linux V1: [OMPPARAMS] = '-DUSEOMP' CFLAGS="\$CFLAGS -fopenmp" LDFLAGS="\$LDFLAGS -fopenmp"
%  Linux V2: [OMPPARAMS] = '-DUSEOMP' CXXFLAGS="\$CXXFLAGS -fopenmp" LDFLAGS="\$LDFLAGS -fopenmp"

